# pandas.core.window.Rolling.apply

`Rolling.``apply`(func, raw=None, args=(), kwargs={})

  The rolling function’s apply function.

  Parameters:

  func : function

  > Must produce a single value from an ndarray input if `raw=True` or a single value from a Series if `raw=False`.

  raw : bool, default None

  > - `False` : passes each row or column as a Series to the function.
  > - `True` or `None` : the passed function will receive ndarray objects instead. If you are just applying a NumPy reduction function this will achieve much better performance.

  > The raw parameter is required and will show a FutureWarning if not passed. In the future raw will default to False.

  > New in version 0.23.0.

  *args, **kwargs

  > Arguments and keyword arguments to be passed into func.

  Returns:

  Series or DataFrame

  > Return type is determined by the caller.

  See also

  `Series.rolling`
    Series rolling.
  `DataFrame.rolling`
    DataFrame rolling.

Scroll To Top